Complex Numbers
Numerics
Collaboration diagram for Complex Numbers:

## Classes

struct | std::complex< _Tp >
struct | std::complex< double >
struct | std::complex< float >
struct | std::complex< long double >

## Functions

constexpr | std::complex< float >::complex (const complex< double > &)
constexpr | std::complex< float >::complex (const complex< long double > &)
constexpr | std::complex< double >::complex (const complex< long double > &)
template<typename _Tp >
_Tp | std::__complex_abs (const complex< _Tp > &__z)
template<typename _Tp >
std::complex< _Tp > | std::tr1::__complex_acosh (const std::complex< _Tp > &__z)
template<typename _Tp >
_Tp | std::__complex_arg (const complex< _Tp > &__z)
template<typename _Tp >
std::complex< _Tp > | std::tr1::__complex_asinh (const std::complex< _Tp > &__z)
template<typename _Tp >
std::complex< _Tp > | std::tr1::__complex_atanh (const std::complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_cos (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_cosh (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_exp (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_log (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_pow (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::__complex_pow_unsigned (complex< _Tp > __x, unsigned __n)
template<typename _Tp >
complex< _Tp > | std::__complex_sin (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_sinh (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_sqrt (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_tan (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::__complex_tanh (const complex< _Tp > &__z)
template<typename _Tp >
_Tp | std::abs (const complex< _Tp > &)
template<typename _Tp >
std::complex< _Tp > | std::tr1::acosh (const std::complex< _Tp > &__z)
template<typename _Tp >
_Tp | std::arg (const complex< _Tp > &)
template<typename _Tp >
std::complex< _Tp > | std::tr1::asinh (const std::complex< _Tp > &__z)
template<typename _Tp >
std::complex< _Tp > | std::tr1::atanh (const std::complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::conj (const complex< _Tp > &)
template<typename _Tp >
std::complex< _Tp > | std::tr1::conj (const std::complex< _Tp > &__z)
template<typename _Tp >
std::complex< typename __gnu_cxx::__promote< _Tp >::__type > | std::tr1::conj (_Tp __x)
template<typename _Tp >
complex< _Tp > | std::cos (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::cosh (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::exp (const complex< _Tp > &)
template<typename _Tp >
std::complex< _Tp > | std::tr1::fabs (const std::complex< _Tp > &__z)
template<typename _Tp >
constexpr _Tp | std::imag (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::log (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::log10 (const complex< _Tp > &)
template<typename _Tp >
_Tp | std::norm (const complex< _Tp > &)
complex< _Tp > & | std::complex< _Tp >::operator*= (const _Tp &)
template<typename _Up >
complex< _Tp > & | std::complex< _Tp >::operator*= (const complex< _Up > &)
template<typename _Tp >
complex< _Tp > | std::operator+ (const complex< _Tp > &__x)
template<typename _Up >
complex< _Tp > & | std::complex< _Tp >::operator+= (const complex< _Up > &)
template<typename _Tp >
complex< _Tp > | std::operator- (const complex< _Tp > &__x)
template<typename _Up >
complex< _Tp > & | std::complex< _Tp >::operator-= (const complex< _Up > &)
complex< _Tp > & | std::complex< _Tp >::operator/= (const _Tp &)
template<typename _Up >
complex< _Tp > & | std::complex< _Tp >::operator/= (const complex< _Up > &)
template<typename _Tp , typename _CharT , class _Traits >
basic_ostream< _CharT, _Traits > & | std::operator<< (basic_ostream< _CharT, _Traits > &__os, const complex< _Tp > &__x)
complex< _Tp > & | std::complex< _Tp >::operator= (const _Tp &)
template<typename _Up >
complex< _Tp > & | std::complex< _Tp >::operator= (const complex< _Up > &)
template<typename _Tp , typename _CharT , class _Traits >
basic_istream< _CharT, _Traits > & | std::operator>> (basic_istream< _CharT, _Traits > &__is, complex< _Tp > &__x)
template<typename _Tp >
complex< _Tp > | std::polar (const _Tp &, const _Tp &=0)
template<typename _Tp , typename _Up >
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::polar (const _Tp &__rho, const _Up &__theta)
template<typename _Tp >
complex< _Tp > | std::pow (const complex< _Tp > &, int)
template<typename _Tp >
complex< _Tp > | std::pow (const complex< _Tp > &, const _Tp &)
template<typename _Tp >
complex< _Tp > | std::pow (const complex< _Tp > &, const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::pow (const _Tp &, const complex< _Tp > &)
template<typename _Tp , typename _Up >
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::pow (const std::complex< _Tp > &__x, const _Up &__y)
template<typename _Tp , typename _Up >
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::pow (const _Tp &__x, const std::complex< _Up > &__y)
template<typename _Tp , typename _Up >
std::complex< typename __gnu_cxx::__promote_2< _Tp, _Up >::__type > | std::tr1::pow (const std::complex< _Tp > &__x, const std::complex< _Up > &__y)
template<typename _Tp >
std::complex< _Tp > | std::tr1::pow (const std::complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
std::complex< _Tp > | std::tr1::pow (const _Tp &__x, const std::complex< _Tp > &__y)
template<typename _Tp >
std::complex< _Tp > | std::tr1::pow (const std::complex< _Tp > &__x, const std::complex< _Tp > &__y)
template<typename _Tp >
constexpr _Tp | std::real (const complex< _Tp > &__z)
template<typename _Tp >
complex< _Tp > | std::sin (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::sinh (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::sqrt (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::tan (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::tanh (const complex< _Tp > &)
template<typename _Tp >
complex< _Tp > | std::operator+ (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator+ (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
complex< _Tp > | std::operator+ (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator- (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator- (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
complex< _Tp > | std::operator- (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator* (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator* (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
complex< _Tp > | std::operator* (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator/ (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
complex< _Tp > | std::operator/ (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
complex< _Tp > | std::operator/ (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp >
constexpr bool | std::operator== (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
constexpr bool | std::operator== (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
constexpr bool | std::operator== (const _Tp &__x, const complex< _Tp > &__y)
template<typename _Tp >
constexpr bool | std::operator!= (const complex< _Tp > &__x, const complex< _Tp > &__y)
template<typename _Tp >
constexpr bool | std::operator!= (const complex< _Tp > &__x, const _Tp &__y)
template<typename _Tp >
constexpr bool | std::operator!= (const _Tp &__x, const complex< _Tp > &__y)

## Detailed Description

Classes and functions for complex numbers.

## Function Documentation

## abs()

template<typename _Tp >

_Tp std::abs | ( | const complex< _Tp > & | __z | ) |

inline

Return magnitude of z.

Definition at line 601 of file complex.

Referenced by std::binomial_distribution< _IntType >::operator()(), and std::poisson_distribution< _IntType >::operator()().

## acosh()

template<typename _Tp >

std::complex< _Tp > std::tr1::acosh | ( | const std::complex< _Tp > & | __z | ) |

inline

acosh(__z) [8.1.5].

Definition at line 215 of file tr1/complex.

## arg()

template<typename _Tp >

_Tp std::arg | ( | const complex< _Tp > & | __z | ) |

inline

Return phase angle of z.

Definition at line 628 of file complex.

## asinh()

template<typename _Tp >

std::complex< _Tp > std::tr1::asinh | ( | const std::complex< _Tp > & | __z | ) |

inline

asinh(__z) [8.1.6].

Definition at line 254 of file tr1/complex.

## atanh()

template<typename _Tp >

std::complex< _Tp > std::tr1::atanh | ( | const std::complex< _Tp > & | __z | ) |

inline

atanh(__z) [8.1.7].

Definition at line 298 of file tr1/complex.

## conj()

template<typename _Tp >

complex< _Tp > std::conj | ( | const complex< _Tp > & | __z | ) |

inline

Return complex conjugate of z.

Definition at line 674 of file complex.

## cos()

template<typename _Tp >

complex< _Tp > std::cos | ( | const complex< _Tp > & | __z | ) |

inline

Return complex cosine of z.

Definition at line 706 of file complex.

## cosh()

template<typename _Tp >

complex< _Tp > std::cosh | ( | const complex< _Tp > & | __z | ) |

inline

Return complex hyperbolic cosine of z.

Definition at line 736 of file complex.

## exp()

template<typename _Tp >

complex< _Tp > std::exp | ( | const complex< _Tp > & | __z | ) |

inline

Return complex base e exponential of z.

Definition at line 762 of file complex.

Referenced by std::lognormal_distribution< _RealType >::operator()().

## fabs()

template<typename _Tp >

std::complex< _Tp > std::tr1::fabs | ( | const std::complex< _Tp > & | __z | ) |

inline

fabs(__z) [8.1.8].

Definition at line 307 of file tr1/complex.

## log()

template<typename _Tp >

complex< _Tp > std::log | ( | const complex< _Tp > & | __z | ) |

inline

Return complex natural logarithm of z.

Definition at line 789 of file complex.

Referenced by std::generate_canonical(), std::normal_distribution< result_type >::operator()(), std::gamma_distribution< result_type >::operator()(), std::binomial_distribution< _IntType >::operator()(), std::poisson_distribution< _IntType >::operator()(), std::exponential_distribution< _RealType >::operator()(), std::operator<<(), and std::operator>>().

## log10()

template<typename _Tp >

complex< _Tp > std::log10 | ( | const complex< _Tp > & | __z | ) |

inline

Return complex base 10 logarithm of z.

Definition at line 794 of file complex.

## norm()

template<typename _Tp >

_Tp std::norm | ( | const complex< _Tp > & | __z | ) |

inline

Return z magnitude squared.

Definition at line 661 of file complex.

## operator!=() [1/3]

template<typename _Tp >

constexpr bool std::operator!= | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return false if x is equal to y.

Definition at line 476 of file complex.

## operator!=() [2/3]

template<typename _Tp >

constexpr bool std::operator!= | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Return false if x is equal to y.

Definition at line 481 of file complex.

## operator!=() [3/3]

template<typename _Tp >

constexpr bool std::operator!= | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return false if x is equal to y.

Definition at line 486 of file complex.

## operator*() [1/3]

template<typename _Tp >

complex<_Tp> std::operator* | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x times y.

Definition at line 386 of file complex.

## operator*() [2/3]

template<typename _Tp >

complex<_Tp> std::operator* | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Return new complex value x times y.

Definition at line 395 of file complex.

## operator*() [3/3]

template<typename _Tp >

complex<_Tp> std::operator* | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x times y.

Definition at line 404 of file complex.

## operator*=() [1/2]

template<typename _Tp >

complex< _Tp > & std::complex< _Tp >::operator*= | ( | const _Tp & | __t | ) |

Multiply this complex number by a scalar.

Definition at line 245 of file complex.

## operator*=() [2/2]

template<typename _Tp >
template<typename _Up >

complex< _Tp > & std::complex< _Tp >::operator*= | ( | const complex< _Up > & | __z | ) |

Multiply this complex number by another.

Definition at line 299 of file complex.

## operator+() [1/4]

template<typename _Tp >

complex<_Tp> std::operator+ | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x plus y.

Definition at line 326 of file complex.

Referenced by std::operator+().

## operator+() [2/4]

template<typename _Tp >

complex<_Tp> std::operator+ | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Return new complex value x plus y.

Definition at line 335 of file complex.

## operator+() [3/4]

template<typename _Tp >

complex<_Tp> std::operator+ | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x plus y.

Definition at line 344 of file complex.

## operator+() [4/4]

template<typename _Tp >

complex<_Tp> std::operator+ | ( | const complex< _Tp > & | __x | ) |

inline

Return x.

Definition at line 445 of file complex.

## operator+=()

template<typename _Tp >
template<typename _Up >

complex< _Tp > & std::complex< _Tp >::operator+= | ( | const complex< _Up > & | __z | ) |

Add another complex number to this one.

Definition at line 276 of file complex.

## operator-() [1/4]

template<typename _Tp >

complex<_Tp> std::operator- | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x minus y.

Definition at line 356 of file complex.

## operator-() [2/4]

template<typename _Tp >

complex<_Tp> std::operator- | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Return new complex value x minus y.

Definition at line 365 of file complex.

## operator-() [3/4]

template<typename _Tp >

complex<_Tp> std::operator- | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x minus y.

Definition at line 374 of file complex.

## operator-() [4/4]

template<typename _Tp >

complex<_Tp> std::operator- | ( | const complex< _Tp > & | __x | ) |

inline

Return complex negation of x.

Definition at line 451 of file complex.

## operator-=()

template<typename _Tp >
template<typename _Up >

complex< _Tp > & std::complex< _Tp >::operator-= | ( | const complex< _Up > & | __z | ) |

Subtract another complex number from this one.

Definition at line 287 of file complex.

## operator/() [1/3]

template<typename _Tp >

complex<_Tp> std::operator/ | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x divided by y.

Definition at line 416 of file complex.

## operator/() [2/3]

template<typename _Tp >

complex<_Tp> std::operator/ | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Return new complex value x divided by y.

Definition at line 425 of file complex.

## operator/() [3/3]

template<typename _Tp >

complex<_Tp> std::operator/ | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return new complex value x divided by y.

Definition at line 434 of file complex.

## operator/=() [1/2]

template<typename _Tp >

complex< _Tp > & std::complex< _Tp >::operator/= | ( | const _Tp & | __t | ) |

Divide this complex number by a scalar.

Definition at line 255 of file complex.

## operator/=() [2/2]

template<typename _Tp >
template<typename _Up >

complex< _Tp > & std::complex< _Tp >::operator/= | ( | const complex< _Up > & | __z | ) |

Divide this complex number by another.

Definition at line 312 of file complex.

## operator<<()

template<typename _Tp , typename _CharT , class _Traits >

basic_ostream<_CharT, _Traits>& std::operator<< | ( | basic_ostream< _CharT, _Traits > & | __os,
|  | const complex< _Tp > & | __x
| ) |  |

Insertion operator for complex values.

Definition at line 526 of file complex.

## operator=() [1/2]

template<typename _Tp >

complex< _Tp > & std::complex< _Tp >::operator= | ( | const _Tp & | __t | ) |

Assign a scalar to this complex number.

Definition at line 235 of file complex.

## operator=() [2/2]

template<typename _Tp >
template<typename _Up >

complex< _Tp > & std::complex< _Tp >::operator= | ( | const complex< _Up > & | __z | ) |

Assign another complex number to this one.

Definition at line 265 of file complex.

## operator==() [1/3]

template<typename _Tp >

constexpr bool std::operator== | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return true if x is equal to y.

Definition at line 458 of file complex.

## operator==() [2/3]

template<typename _Tp >

constexpr bool std::operator== | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Return true if x is equal to y.

Definition at line 463 of file complex.

## operator==() [3/3]

template<typename _Tp >

constexpr bool std::operator== | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return true if x is equal to y.

Definition at line 468 of file complex.

## operator>>()

template<typename _Tp , typename _CharT , class _Traits >

basic_istream<_CharT, _Traits>& std::operator>> | ( | basic_istream< _CharT, _Traits > & | __is,
|  | complex< _Tp > & | __x
| ) |  |

Extraction operator for complex values.

Definition at line 493 of file complex.

## polar()

template<typename _Tp >

complex< _Tp > std::polar | ( | const _Tp & | __rho,
|  | const _Tp & | __theta = `0`
| ) |  |

inline

Return complex with magnitude rho and angle theta.

Definition at line 669 of file complex.

## pow() [1/5]

template<typename _Tp >

complex< _Tp > std::pow | ( | const complex< _Tp > & | __z,
|  | int | __n
| ) |  |

inline

Return x to the y'th power.

Definition at line 984 of file complex.

Referenced by std::gamma_distribution< result_type >::operator()().

## pow() [2/5]

template<typename _Tp >

complex< _Tp > std::pow | ( | const complex< _Tp > & | __x,
|  | const _Tp & | __y
| ) |  |

Return x to the y'th power.

Definition at line 993 of file complex.

## pow() [3/5]

template<typename _Tp >

complex< _Tp > std::pow | ( | const complex< _Tp > & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return x to the y'th power.

Definition at line 1032 of file complex.

## pow() [4/5]

template<typename _Tp >

complex< _Tp > std::pow | ( | const _Tp & | __x,
|  | const complex< _Tp > & | __y
| ) |  |

inline

Return x to the y'th power.

Definition at line 1038 of file complex.

## pow() [5/5]

template<typename _Tp , typename _Up >

std::complex<typename __gnu_cxx::__promote_2<_Tp, _Up>::__type> std::tr1::pow | ( | const std::complex< _Tp > & | __x,
|  | const _Up & | __y
| ) |  |

inline

Additional overloads [8.1.9].

Definition at line 348 of file tr1/complex.

## sin()

template<typename _Tp >

complex< _Tp > std::sin | ( | const complex< _Tp > & | __z | ) |

inline

Return complex sine of z.

Definition at line 824 of file complex.

## sinh()

template<typename _Tp >

complex< _Tp > std::sinh | ( | const complex< _Tp > & | __z | ) |

inline

Return complex hyperbolic sine of z.

Definition at line 854 of file complex.

## sqrt()

template<typename _Tp >

complex< _Tp > std::sqrt | ( | const complex< _Tp > & | __z | ) |

inline

Return complex square root of z.

Definition at line 898 of file complex.

Referenced by std::normal_distribution< result_type >::operator()(), and std::student_t_distribution< _RealType >::operator()().

## tan()

template<typename _Tp >

complex< _Tp > std::tan | ( | const complex< _Tp > & | __z | ) |

inline

Return complex tangent of z.

Definition at line 925 of file complex.

## tanh()

template<typename _Tp >

complex< _Tp > std::tanh | ( | const complex< _Tp > & | __z | ) |

inline

Return complex hyperbolic tangent of z.

Definition at line 953 of file complex.